
/* Generated by Interface Builder */

#import <appkit/Form.h>
#import "bilsenCCF.h"
#import "Gaussfunc.h"
#import "generalobj.h"
#import "lateralizer.h"
#import "ccf.h"

#define DONE1 		"done with CCF func"
#define DONE2		"done with lat."
#define EMPTY 		"                  "
#define THINKING 	"Thinking..."
#define BADPARAM	"Bad choice of noise parameters"

extern ccf *Lm;
extern id mytext,gaussfunction,lateral;
extern double iid2,mean,deviation;

extern int GRAPHICS;
extern ccf *bilsen(double SPL, double IID, double f0, double bw, double tau, double g);
extern double lateralize(ccf *Lm);
extern void freeccf(ccf *), addtext(id obj, char *str);


@implementation bilsenCCF

- setInc_param:anObject
{
    inc_param = anObject;
    return self;
}

- setIterations:anObject
{
    iterations = anObject;
    return self;
}

- setMessageForm:anObject
{
    messageForm = anObject;
    return self;
}

- setBilsen_param:anObject
{
    bilsen_param = anObject;
    return self;
}

- setspl:anObject
{
	SPL = [anObject getdouble];
	return self;
}

- setfc:anObject
{
	fc = [anObject getdouble];
	return self;
}

- setbw:anObject
{
	bw = [anObject getdouble];
	return self;
}

- settau:anObject
{
	tau = [anObject getdouble];
	return self;
}

- setg:anObject
{
	g = [anObject getdouble];
	return self;
}

- setincfc:anObject
{
	fcinc = [anObject getdouble];
	return self;
}

- setinctau:anObject
{
	tauinc = [anObject getdouble];
	return self;
}

- setincbw:anObject
{
	bwinc = [anObject getdouble];
	return self;
}

- setincg:anObject
{
	ginc = [anObject getdouble];
	return self;
}
- setiid: anObject
{
   iid2 = [anObject getdouble];
   return self;
}

- setiid_inc: anObject
{
     iidinc= [anObject getdouble];
     return self;
 }
 
- setIntensity: anObject
{
    intensity = anObject;
    return self;
 }
 
 - setInten_inc: anObject
 {
     inten_inc = anObject;
     return self;
}


- setiterate:anObject
{
	numiterate = [anObject getint];
	return self;
}

- (char *)dumpParams
{
	char str[200];
	sprintf(str,"BILSEN\nG = %f tau = %f\nbw = %f fc = %f\nSPL = %f\n",g,tau,bw,fc,SPL);
	return str;
}

- later_bilsen:sender
{
    int i;
    double position;
    char str[256];
    
    if (GRAPHICS)
    	{
		[messageForm setStringValue:THINKING at:0];
		NXPing();
    	numiterate = [iterations intValueAt:0];
    	g = [bilsen_param doubleValueAt:0];
    	tau = [bilsen_param doubleValueAt:1];
    	bw = [bilsen_param doubleValueAt:2];
    	fc = [bilsen_param doubleValueAt:3];
		iid2 = [bilsen_param doubleValueAt:4];
    	SPL = [bilsen_param doubleValueAt:5];
    	ginc = [inc_param doubleValueAt:0];
    	tauinc = [inc_param doubleValueAt:1];
    	bwinc = [inc_param doubleValueAt:2];
    	fcinc = [inc_param doubleValueAt:3];
		iidinc = [bilsen_param doubleValueAt:4];
		}
	sprintf(str,";g=%4.2f tau=%4.0f bw=%4.0f fc=%4.0f iid = %3.0f\n",
						g,tau,bw,fc,iid2);
	  addtext(mytext,str);
	  if(ginc!= 0)
	       {
	       x = g;
	       xinc=ginc;
	       sprintf(str,"\n; x = g\n");
	       addtext(mytext,str);
	       }  else if(tauinc!=0)
	       {
	       x = tau;
	       xinc = tauinc;
	       sprintf(str,"\n; x = tau\n");
	       addtext(mytext,str);
	       } else if(fcinc != 0)
	       {
	        x = fc;
	        xinc = fcinc;
	       sprintf(str,"\n; x = fc\n");
	       addtext(mytext,str);
	       } else if(bwinc !=0)
	       {
	        x = bw;
	        xinc = bwinc;
	       sprintf(str,"\n; x = bw\n");
	       addtext(mytext,str);
	        } else if(iidinc != 0)
                {
	        x = iid2;
	        xinc = iidinc;
	       sprintf(str,"\n; x = ts\n");
	       addtext(mytext,str);
	        }
    for(i=1;i<=numiterate;i++,g+=ginc,tau+=tauinc,
    		fc+=fcinc,bw+=bwinc,iid2+=iidinc,x+=xinc)
    	{
    	if ((Lm = bilsen(SPL, iid2, fc, bw, tau, g)) == (ccf *)0) {
			[messageForm setStringValue:BADPARAM at:0];
			sprintf(str, ";bad choice of bilsen parameters\n");
			addtext(mytext, str);
			return self;
		}
		
		[gaussfunction dointensity:self];
		position = [lateral findPosition:self];
		freeccf(Lm);
		
		sprintf(str,"\n%10.3f %5.4f",x,position);
		addtext(mytext,str);
    	}
	if (GRAPHICS)
		{
    	[bilsen_param setDoubleValue:g at:0];
    	[bilsen_param setDoubleValue:tau at:1];
    	[bilsen_param setDoubleValue:bw at:2];
    	[bilsen_param setDoubleValue:fc at:3];
    	[bilsen_param setDoubleValue:iid2 at:4];
    	[bilsen_param setDoubleValue:SPL at:5];
    	[messageForm setStringValue:DONE2 at:0];
		}
    return self;
}

- ccf_bilsen:sender
{
	char str[256];
	
	if (GRAPHICS)
		{
    	[messageForm setStringValue:THINKING at:0];
		NXPing();
    	g = [bilsen_param doubleValueAt:0];
    	tau = [bilsen_param doubleValueAt:1];
    	bw = [bilsen_param doubleValueAt:2];
    	fc = [bilsen_param doubleValueAt:3];
		iid2 = [bilsen_param doubleValueAt:4];
    	SPL = [bilsen_param doubleValueAt:5];
 		}
    Lm = bilsen(SPL, iid2, fc, bw, tau, g);
	if (Lm == (ccf *)0) {
		[messageForm setStringValue:BADPARAM at:0];
		sprintf(str, ";bad choice of bilsen parameters\n");
		addtext(mytext, str);
		return self;
	}	

    [gaussfunction dointensity:self];
    putinfoccf(Lm,[self dumpParams]);
    sprintf(str,";g=%3.2f tau=%3.2f bw=%4.0f fc=%4.0f\n",g,tau,bw,fc);
    addtext(mytext,str);
    if (GRAPHICS)
		[messageForm setStringValue:DONE1 at:0];
    return self;
}


@end
