/*
*	(10-2-88)	TOR- copied from DetectTinN.c and modified.
*	(6-20-89)	TOR- adapted for NeXT.
*/

#include <stdio.h>
#include <math.h>
#include "ccf.h"
#include "BiDis.h"
#include "Nerve.h"

extern int errno;

#define RADPERDEG	(PI/180.0)
#define WARNING		1	/* Define to enable TSPLtooBig warning msg. */

extern double	ToneNoiseActive(double tspl,double tf,double nspl,
						double nfl,double nfh,double fm),
				NoiseActive(double spl,double fl,double fh,
							double fm),
				NoiseCCF(double spl,double fl,double fh,
                   		double td,double ps,double fm,
						double *outp,int tup,double tstep);
extern double 	HmSqd(double f, double fm),
				ptau(double t),
				Sqrt(double f);
extern int 	ptauinit(double f),
			isinregion(double fc,double f0,double frac);
extern 	nrectify(double vart,double tf,double ttd,double varn,
                	double *np,int tup,double tstep,double *op),
		lowpass(double *sig,int tup,double tstep);
extern execerror(char *s, char *t);

ccf *tinn(NSPL,Nfl,Nfh,Ntd,Nps,TSPL,Tf,Tps)
	double NSPL,Nfl,Nfh,Ntd,Nps,TSPL,Tf,Tps;
{
	double	Frac2, Frac1, Frac0, FracTN, FracN,Frac,
		VarTm, VarT, Varm, fm,
		FRate = pow(10.0, DISP_FSTEP),
		ps = Tps * RADPERDEG,
		Fstrt = -1.0, Fstop = -1.0;
	int	freqdep = ptauinit(500.);
	double UnRctArray[-DISP_TLOW+DISP_TUP+1];
	double *UnRctp = &UnRctArray[-DISP_TLOW];
	double Tmp[-DISP_TLOW+DISP_TUP+1];
	double *Tmpptr = &Tmp[-DISP_TLOW];

	static double VarNm;
	ccf *Lm;

	errno = 0;
	if (isinregion(fm,Tf,Frac) < 0.0) {
		Fstop = Fstrt = Tf;
	}
	else for(fm = 20.; fm <= 10000.; fm *= FRate) {
		Frac = ToneNoiseActive(TSPL, Tf, NSPL, Nfl, Nfh, fm);
		if (Fstrt < 0.0) {
			if (isinregion(fm, Tf, Frac*Frac))
				Fstrt = fm;
		} else if (!isinregion(fm, Tf, Frac*Frac)) {
				Fstop = fm/FRate;
				break;
		}
	}
	
	if (Fstrt<=0 || Fstop<=0)
		execerror("bad choice of parameters for ccf\n", (char *)0);

	VarT = Pow(10.0, TSPL/10.);
	Lm = newccf(log10(Fstrt)/DISP_FSTEP,log10(Fstop)/DISP_FSTEP,DISP_FSTEP,
		(double)DISP_TLOW,(double)DISP_TUP,DISP_TSTEP);
	beg_freq_loop(Lm)
		FracTN = ToneNoiseActive(TSPL, Tf, NSPL, Nfl, Nfh, freq);
		if (freqdep) ptauinit(freq);
		VarTm = HmSqd(Tf, freq) * VarT;
		VarNm = NoiseCCF(NSPL, Nfl, Nfh, Ntd, Nps, freq,
			 UnRctp, DISP_TUP, DISP_TSTEP);
	/* compute rectified tone+noise ccf */
		nrectify(VarTm, Tf, (Tps/360.)*(1000./Tf),
			VarNm, UnRctp, DISP_TUP, DISP_TSTEP, Lm->R[f]);
		lowpass(Lm->R[f], DISP_TUP, DISP_TSTEP);
		Frac2 = FracTN*FracTN;
		Frac0 = (1.-FracTN)*(1.-FracTN);
		Frac1 = 1. - Frac2 - Frac0;

		/* Include singly-active and inactive fibers in correct
		*  proportions. */
		Frac2 *= DISP_NFIBERS_STEP;
		Frac0 = (Frac1 *NERVE_SPONT_RATE*NERVE_ACTIVE_RATE +
			 Frac0 *NERVE_SPONT_RATE*NERVE_SPONT_RATE) *
			DISP_NFIBERS_STEP;

		beg_t_loop(Lm)
			if (Lm->R[f][t] < 0.0) Lm->R[f][t] = 0.0;
		end_t_loop
	end_freq_loop
	return Lm;
}

