
/* Generated by Interface Builder */
/* XXu  3-19-90  fixed a bug in savePtau    */

#import <appkit/Button.h>
#import <appkit/Form.h>
#import <strings.h>
#import "filerCCF.h"
#import "generalobj.h"
#import "ccf.h"
#import "BiDis.h"
#import "ptauParams.h"

extern	ccf *Lm;
extern	ccf *map();
extern	id mytext;
extern	int GRAPHICS;
extern	double Fup, Flow;							// CCF parameters
extern	double testmv(double x, double f, double t);	// Li parameters
extern	double mean, deviation;
extern	int azimuth;
extern	double lF, lP, hF, hP, MuF, MuP, Fthresh;	// Ptau parameters
extern	double ptau(double);
extern	double ptaumap(double x, double f, double t),
		freq_sal_map(double x, double f, double t);
extern	ptauinit(double f),
		gaussinit(double m, double v),
		addtext(id obj, char *str);

@implementation filerCCF

#define CCF_DONE	"CCF already in memory"
#define CCF_EMPTY	"No CCF in memory -- use options to select functions to save/write"

+ new
{
	id obj;

	self = [super new];
	obj = [generalobj new];
	[obj setstring:"CCF plot"];
	[self settitle:obj];
	[obj setstring:"CF (Hz)"];
	[self setflabel:obj];
	[obj setstring:"Internal Delay (ms)"];
	[self settlabel:obj];
	[obj setstring:"Mag"];
	[self setzlabel:obj];
	
	return self;
}

- changeSwOptions:sender
{
	if ([sender selectedTag])	// assumes ptau switch is second one (tag=1)
		swPtau = (BOOL) [[sender selectedCell] state];
    else
		swIntensity = (BOOL) [[sender selectedCell] state];
    return self;
}

- changeSwForm:sender
{
	int swF;
	swFrequency = [sender doubleValueAt:0];
	
	// if no CCF, just correct negative frequencies
	if (Lm == NULL || Lm->storage == NULL) {
		if (swFrequency < 0) {
			swFrequency = 500.0;
			[sender setDoubleValue:swFrequency];
		}
		return self;
	}
	
	swF = dtoi(Log10(swFrequency) / Lm->fstep);	// convert freq. to f index
	
	if (swF < Lm->f_low  ||  swF > Lm->f_up) {
		[messageForm setStringValue:"Chosen char. freq. out of CCF's range -- using 500 Hz for now"];
		swFrequency = 500.0;
		[sender setDoubleValue:swFrequency];
	}

	return self;
}



- setname:anObject
{
	strcpy(name, [anObject getstring]);
	return self;
}

- settitle:anObject
{
	strcpy(title, [anObject getstring]);
	return self;
}

- settlabel:anObject
{
	strcpy(tlabel, [anObject getstring]);
	return self;
}

- setflabel:anObject
{
	strcpy(flabel, [anObject getstring]);
	return self;
}

- setzlabel:anObject
{
	strcpy(zlabel, [anObject getstring]);
	return self;
}

- loadCCF:sender
{
    if (GRAPHICS) strcpy(name,[nameForm stringValueAt:0]);
    Lm = ccfread(name);
    return self;
}

- savePtauCCF:sender
{
    char str[100];
    double sum;
    if (GRAPHICS) {
		strcpy(name,[nameForm stringValueAt:0]);
		strcpy(title,[nameForm stringValueAt:1]);
		strcpy(tlabel,[nameForm stringValueAt:2]);
		strcpy(flabel,[nameForm stringValueAt:3]);
		strcpy(zlabel,[nameForm stringValueAt:4]);
    }
    ptauinit(500.);
    
    /* Check if Lm obj. exists, then check to see if Lm is free */
    if (Lm!=NULL && Lm->storage!=NULL) {
	formatccf(Lm, 1.0, 250.0, 0.0, tlabel, flabel, zlabel, title);
	sprintf(str, "Saved with Ptau\nUsed NREALPTS=%d\n", NREALPTS);
	putinfoccf(Lm, str);
    	Lm = ccfsave(map(ptaumap, Lm), name);
	freeccf(Lm);
    } else {
	Lm = newccf(log10(Flow)/DISP_FSTEP,log10(Fup)/DISP_FSTEP,
		DISP_FSTEP,(double)DISP_TLOW,(double)DISP_TUP,DISP_TSTEP);
	formatccf(Lm,1.0,250.0,0.0,tlabel,flabel,zlabel,title);
	sprintf(str,"Saved only Ptau\nUsed NREALPTS=%d\n",NREALPTS);
	putinfoccf(Lm,str);
	Lm = ccfsave(map(ptaumap,ccffill(Lm,1.0)),name);
	/* */
	if(Flow==Fup) {
	   int f= Lm->f_up;
	   int  t;
	   sum = 0.0;
	   for(t=Lm->t_low;t<=Lm->t_up;t++)
	   sum += Lm->R[f][t]*Lm->R[f][t];
	   for(t=Lm->t_low;t<=Lm->t_up;t++)
	          printf("\n %d, %f", t, Lm->R[f][t]/sum);
	}
	  
	freeccf(Lm);
    }
    return self;
}

- savePtLi:sender
{
    char str[100];
    double sum;
    if (GRAPHICS) {
		strcpy(name,[nameForm stringValueAt:0]);
		strcpy(title,[nameForm stringValueAt:1]);
		strcpy(tlabel,[nameForm stringValueAt:2]);
		strcpy(flabel,[nameForm stringValueAt:3]);
		strcpy(zlabel,[nameForm stringValueAt:4]);
    }
    ptauinit(500.);
    if (Lm!=NULL && Lm->storage!=NULL) {
	formatccf(Lm,1.0,250.0,0.0,tlabel,flabel,zlabel,title);
	sprintf(str,"Saved with Ptau\nUsed NREALPTS=%d\n",NREALPTS);
	putinfoccf(Lm,str);
	Lm = map(testmv,Lm);
    	Lm = ccfsave(map(ptaumap,Lm),name);
	freeccf(Lm);
    } else {
	Lm = newccf(log10(Flow)/DISP_FSTEP,log10(Fup)/DISP_FSTEP,
		DISP_FSTEP,(double)DISP_TLOW,(double)DISP_TUP,DISP_TSTEP);
	formatccf(Lm,1.0,250.0,0.0,tlabel,flabel,zlabel,title);
	sprintf(str,"Saved only Ptau\nUsed NREALPTS=%d\n",NREALPTS);
	putinfoccf(Lm,str);
	Lm = map(testmv,ccffill(Lm,1.0));
	Lm = ccfsave(map(ptaumap,Lm),name);
	/* */
	if(Flow == Fup)
	{
	 int f = Lm->f_up;
	int t ;
	sum = 0.0;
	for(t=Lm->t_low;t<=Lm->t_up;t++)
	 sum+=Lm->R[f][t]*Lm->R[f][t];
	for(t=Lm->t_low;t<= Lm->t_up;t++)
	          printf("\n %d, %f", t, Lm->R[f][t]/sum);
		  }
	  /* */
	freeccf(Lm);
      }
    return self;
}

- saveCCF:sender
{
    FILE *fp;
    char str[100];
	ccf	 *Rm;
	
	// If user wants to save CCF @ single CF, redo CCF using one fiber
	// We could use the value in the form; however, let's use the options
	// only when no CCF exists
	sprintf(str, "Saving CCF...");
	[messageForm setStringValue:str at:0];

    if (GRAPHICS) {	// Read filename, title, axis labels
		strcpy(name,  [nameForm stringValueAt:0]);
		strcpy(title, [nameForm stringValueAt:1]);
		strcpy(tlabel,[nameForm stringValueAt:2]);
		strcpy(flabel,[nameForm stringValueAt:3]);
		strcpy(zlabel,[nameForm stringValueAt:4]);
    }
	if ((fp=fopen(name, "w"))==NULL) {
		[messageForm setStringValue:"Can't open filename specified!" at:0];
		return self;
	}
    
    if (Lm!=NULL && Lm->storage!=NULL) {	// CCF exists
		formatccf(Lm, 1.0, 250.0, 0.0, tlabel, flabel, zlabel, title);
		sprintf(str, "Used NREALPTS=%d\n", NREALPTS);
		putinfoccf(Lm, str);
    } else {
		// no CCF in memory, use freq. specified; else use prev. Flow/Fup
		// yeah, it's not great prog. practice, but we're not using this often
		printf("Flow = %f	Fup = %f \n", Flow, Fup);
		Lm=newccf(log10(Flow)/DISP_FSTEP, log10(Fup)/DISP_FSTEP,
				  DISP_FSTEP, (double)DISP_TLOW, (double)DISP_TUP,
				  DISP_TSTEP);
		formatccf(Lm, 1.0, 250.0, 0.0, tlabel, flabel, zlabel, title);
		Lm = ccffill(Lm, 1.0);	// Create empty CCF (amplitude = 1)

	}
	
	if (swIntensity) {
		Lm = map(testmv, Lm);
	}
		
	if (swPtau) {
		beg_freq_loop(Lm)
			ptauinit(freq);
			beg_time_loop(Lm)
				/* frequency salience:  p(f, t) --> p(f, t)q(f) */
				/* c->R[f][t] *= freq_salience(1.0, freq)*ptau(time); */
				Lm->R[f][t] *= ptau(time);
			end_time_loop
		end_freq_loop
	}
	
	/************************** Crunch Options *************************/
	switch([crunchOptions selectedTag]) {
		double elements;
		
		case 0:		//No crunching
			Rm = ccfcopy(Lm);
			formatccf(Rm, 1.0, 250.0, 0.0, tlabel, flabel, zlabel, title);
			break;
			
		case 1:		//Crunch times onto one frequency-axis
			elements = (double) (Lm->t_up - Lm->t_low) + 1.0;
			Rm = newccf(Lm->f_low, Lm->f_up, DISP_FSTEP, 0, 0, DISP_TSTEP);
 
			//fprintf(fp, ";CCF crunched to freq. axis\n");
			//fprintf(fp, ";frequency\tfiring rate (norm. by %.0f)\n", elements);
			beg_freq_loop(Lm)
				double sum = 0.0;
				beg_t_loop(Lm)
					sum += Lm->R[f][t];
				end_t_loop
				//fprintf(fp, "%.2f\t%.4g\n", freq, sum/elements);
				Rm->R[f][0] = sum;
			end_freq_loop
			
			formatccf(Rm, 1.0, 250.0, 0.0, tlabel, flabel, zlabel, title);
			break;
			
		case 2:		//Crunch frequencies onto one time-axis
			elements = (double) (Lm->f_up - Lm->f_low) + 1.0;
			Rm = newccf(0.0, 0.0, DISP_FSTEP, (double)DISP_TLOW, (double)DISP_TUP, DISP_TSTEP);
	
			//fprintf(fp, ";CCF crunched to time axis\n");
			//fprintf(fp, ";time\tfiring rate (norm. by %.0f)\n", elements);
	
			beg_time_loop(Lm)
				double sum = 0.0;
				beg_f_loop(Lm)
					sum += Lm->R[f][t];
				end_f_loop
				//fprintf(fp, "%.2f\t%.4g\n", time, sum/elements);
				Rm->R[0][t] = sum;
			end_time_loop
			formatccf(Rm, 1.0, 250.0, 0.0, tlabel, flabel, zlabel, title);

			break;
	}

	ccfsave(Rm, name);
	sprintf(str, "Done.");
	[messageForm setStringValue:str at:0];
	freeccf(Lm);
	freeccf(Rm);

    return self;
}

/*************************************************************************
	The writeCCF: method will dump out the normalized values of a CCF
	or of the Li/Ptau functions.  It does this for one frequency, since
	we don't normally look at the numerical values of the CCF.
 *************************************************************************/
- writeCCF:sender
{
    FILE *fp;
	int swF;	// int CCF index corresponding to double swFrequency
	int crunch_flag = [crunchOptions selectedTag];
	double largest=0;
	char str[100];
	
	if (GRAPHICS) {	// Read filename, title, axis labels
		strcpy(name,  [nameForm stringValueAt:0]);
		strcpy(title, [nameForm stringValueAt:1]);
		strcpy(tlabel,[nameForm stringValueAt:2]);
		strcpy(flabel,[nameForm stringValueAt:3]);
		strcpy(zlabel,[nameForm stringValueAt:4]);
    }
    
	if ((fp=fopen(name, "w"))==NULL) {
		[messageForm setStringValue:"Can't open filename specified!" at:0];
		return self;
	}
	
	//If we don't want to crunch, and we want to use ptau
	//Assume that we only want to write values @ a single char. freq
	if (!crunch_flag) {
		if (swFrequency <= 0) {	//Get frequency to write
			[messageForm setStringValue:"Please enter a frequency to use."];
			return self;
		} else {
			swF = dtoi(Log10(swFrequency)/DISP_FSTEP); // need these due to roundoff
			swFrequency = pow(pow(10.0, DISP_FSTEP), (double) swF);
			sprintf(str, "Writing CCF values at %.2f Hz...\007", swFrequency);
			[messageForm setStringValue:str at:0];
		}
	
		if (Lm==NULL || Lm->storage==NULL ) {
			// Create temporary CCF with one frequency
			Lm=newccf(log10(swFrequency)/DISP_FSTEP, log10(swFrequency)/DISP_FSTEP, DISP_FSTEP, (double)DISP_TLOW, (double)DISP_TUP, DISP_TSTEP);
			formatccf(Lm, 1.0, 250.0, 0.0, tlabel, flabel, zlabel, title);
			ccffill(Lm, 1.0);	// Create empty CCF (amplitude = 1)
		}
	
		if (swPtau) {
			ptauinit(swFrequency);
			beg_time_loop(Lm)
				/* frequency salience:  p(f, t) --> p(f, t)q(f) */
				/* c->R[f][t] *= freq_salience(1.0, freq)*ptau(time); */
				Lm->R[swF][t] *= ptau(time);
			end_time_loop
			fprintf(fp, ";lF=%.4f, lP=%4f\n", lF, lP);
			fprintf(fp, ";hF=%.4f, hP=%4f\n", hF, hP);
			fprintf(fp, ";MuF=%.4f, MuP=%4f\n", MuF, MuP);
			fprintf(fp, ";Fthresh=%4f\n", Fthresh);
		}
		
		if (swIntensity) {
			map(testmv, Lm);
			fprintf(fp, ";mean = %f, width = %f, azimuth = %d\n",
					mean, deviation, azimuth);
		}
		
		beg_t_loop(Lm)
			if (Lm->R[swF][t] > largest)
				largest = Lm->R[swF][t];
		end_t_loop
		
		fprintf(fp, ";CCF values written at %.1f Hz\n", swFrequency);
		fprintf(fp, ";ts\tfiring rate (norm. by %e)\n", largest);
		
		beg_time_loop(Lm)
			fprintf(fp, "%.2f\t%.4g\n", time, Lm->R[swF][t]/largest);
		end_time_loop
		
		fprintf(fp, "\n");
		fclose(fp);
		[messageForm setStringValue:"Done." at:0];
		
		freeccf(Lm);
		return self;
	}

 	/************************** Crunch is here *************************/

	if (Lm==NULL || Lm->storage==NULL ) {
		/* swFrequency */
		//Lm=newccf(log10(500)/DISP_FSTEP, log10(1500)/DISP_FSTEP, DISP_FSTEP, (double)DISP_TLOW, (double)DISP_TUP, DISP_TSTEP);
		//formatccf(Lm, 1.0, 250.0, 0.0, tlabel, flabel, zlabel, title);
		//ccffill(Lm, 1.0);	// Create empty CCF (amplitude = 1)

		[messageForm setStringValue:"No CCF available."];
		return self;
	}

	if (swPtau) {
		beg_freq_loop(Lm)
			ptauinit(freq);
			/* frequency salience:  p(f, t) --> p(f, t)q(f) */
			/* Lm->R[f][t] *= freq_salience(1.0, freq)*ptau(time); */
			beg_time_loop(Lm)
				Lm->R[f][t] *= ptau(time);
			end_time_loop
		end_freq_loop

		fprintf(fp, ";lF=%.4f, lP=%4f\n", lF, lP);
		fprintf(fp, ";hF=%.4f, hP=%4f\n", hF, hP);
		fprintf(fp, ";MuF=%.4f, MuP=%4f\n", MuF, MuP);
		fprintf(fp, ";Fthresh=%4f\n", Fthresh);
	}
	
	if (swIntensity) {
		map(testmv, Lm);
		fprintf(fp, ";mean = %f, width = %f, azimuth = %d\n",
				mean, deviation, azimuth);
	}

	switch(crunch_flag) {
		double elements;
		case 1:		//Crunch times onto one frequency-axis
			elements = (double) (Lm->t_up - Lm->t_low) + 1.0;
	
			fprintf(fp, ";CCF crunched to frequency axis\n");
	
			beg_freq_loop(Lm)
				double sum = 0.0;
				beg_t_loop(Lm)
					sum += Lm->R[f][t];
				end_t_loop
				fprintf(fp, "%.2f\t%.4g\n", freq, sum);
			end_freq_loop
			break;
			
		case 2:		//Crunch frequencies onto one time-axis
			elements = (double) (Lm->f_up - Lm->f_low) + 1.0;
	
			fprintf(fp, ";CCF crunched to time axis\n");
	
			beg_time_loop(Lm)
				double sum = 0.0;
				beg_f_loop(Lm)
					sum += Lm->R[f][t];
				end_f_loop
				fprintf(fp, "%.2f\t%.4g\n", time, sum);
			end_time_loop
			break;
	}
	
	fclose(fp);
	[messageForm setStringValue:"Done." at:0];
	
	freeccf(Lm);
	return self;
}

@end
