/* This version calculates P' = P + k*IID */

/*****************************************************************************
	This is the file on 9/16/91, before the modifications to make the
	intensity weighting a linear scaling of P, based on IID.  Intensity
	doesn't occur based on centroid; the weighting occurs by adding a
	an amount proportional to the IID to P
	
 *****************************************************************************/
 
 /* Generated by Interface Builder */
/* TOR - wrote 6-27-89.  I realize that If I would have known
   all about objective-C before beginning this project, I could
   have probably set up this program more efficiently.(like a 
   ccf object, which has methods to calculate tone, noise ,lateralize
   etc. */
 /* XXU -  1-15-90: Aidded a test mode for given mean and variance (testmv)*/
 /* XXU  - 3-26-90 : Aidded a straightness weighting model    */
 /* XXU  -  3-28-90:  Re-constructed the program. Optional functions:
 *                                 Straightness only
 *                                  Straightness + intensity
 *                                  Intensity only
 */

#import <appkit/Button.h>
#import <appkit/Form.h>
#import "Gaussfunc.h"
#import "generalobj.h"
#import "ccf.h"
#import <stdlib.h>

#define	PEAKPICKER_THRESH	(0.9)
#define COMPRESSION_CONST1	(10)
#define COMPRESSION_CONST2	(.048)
#define COMPRESSION_CONST3	(0)

int		strb4_flag;			/* let str. fcn access str. flag */
double	strb4_fstep;		/* let straightness function access str. fstep */
int		strb4_order;		/* let straightness function access order, too */

extern	Fraction *activeTable;
extern	int	GRAPHICS, azindex;
extern	ccf	*Lm;
extern	gaussinit(double m, double v), loadaztable(), loadiidtable();
extern	double	gaussmap(double x,double f,double t),
		testmv(double x,double f,double t),
		iidmap(double x, double f, double t),
		freq_salience(double x, double f),
		freq_sal_map(double x, double f, double t);
extern	double	azimuth, f_old, iid2, mean, deviation;
extern char *globpath(char *);
extern char *strcpy(char *, char *);

id		gaussfunction;
int		OnFlag = 0;
double	additive_slope = 0;	/* global var of pos/IID slope for add. wght */
double	peakpick_thresh = PEAKPICKER_THRESH;	/* add-IID threshold */
int		additive_on = 0;	/* global var for selecting additive-IID wghting */
int		peakpick_on = 0;	/* global var for peak-picking function */
int		compress_on = 0;	/* global var to turn on output compression fcn */
int		raatgever_on = 0;	/* global var to turn on Raatgever weighting */
double	scale = 1;			/* global var for scaling constant */

struct	{
	double	K1;
	double	K2;
	double	K3;
} comprconst = { COMPRESSION_CONST1, COMPRESSION_CONST2, COMPRESSION_CONST3 };


@implementation Gaussfunc

+ new
{
	self = [super new];
	OnFlag = 0;
	gaussfunction = self;
	return self;
}

- setGauss_params:anObject
{
    gauss_params = anObject;
    OnFlag = 0;
    return self;
}

- setGauss_on:anObject
{
    gauss_on = anObject;
    gaussfunction = self;
    return self;
}

- setmean:anObject
{
	mean = [anObject getdouble];
	return self;
}

- setdeviation:anObject
{
	deviation = [anObject getdouble];
	return self;
}

- setStrFlag: anObject
{
      if (!GRAPHICS)
	  	strb4_flag = StrFlag = [anObject getint];
      else
	  	strb4_flag = StrFlag = [Str_on selectedRow];
      return self;
}
 
- setStr_on: anObject
{
    Str_on = anObject;
    return self;
}
 
- setStr_order: anObject
{
	Str_order = anObject;
	return self;
}
 
- setStrbefore_fstep: anObject
{
	Strbefore_fstep = anObject;
	return self;
} 

/* - setPeakPickOn: anObject
{
	return self;
} */


/**************************************************************************
	This is for the terminal version to set a parameter.  Since the terminal
	version doesn't have GRAPHICS, it'll skip the dointensity:sender method;
	consequently, it won't read strb4_fstep there, and that variable is needed
	to dimension the ccf matrix for straightness.  strb4_fstep is the global
	parameter used in skip, which is how many frequency components to skip
	when calc. straightness wghting
***************************************************************************/
- setstrbefore_fstep: anObject	/* get terminal input */
{
	strb4_fstep = beforefstep = [anObject getdouble];
	return self;
}
   

- setpeakpick: anObject		// terminal input for peak-picking option
{
	peakpick_on = [anObject getint];
	return self;
}

- setpeakpickthresh: anObject		// terminal input for peak-picking thresh
{
	peakpick_thresh = [anObject getdouble];
	return self;
}

- setraatgeveron: anObject		// terminal input for Raat. weighting
{
	raatgever_on = [anObject getint];
	return self;
}

- setscale: anObject	// Terminal input for scale factor
{
	scale = [anObject getdouble];
	if (scale == 0)
		scale = 1;
	return self;
}


- setadditiveon: anObject	// Terminal input for additive-IID on flag
{
	additive_on = [anObject getint];
	return self;
}

- setadditiveslope: anObject	// Terminal input for additive-IID slope
{
	additive_slope = [anObject getdouble];
	return self;
}

- setcompress:anObject	// terminal input for compression function flag
{
    compress_on = [anObject getint];
    return self;
}

- setcompressK1:anObject	// terminal input for compression const 1
{
    comprconst.K1 = [anObject getdouble];
    return self;
}

- setcompressK2:anObject	// terminal input for compression const 2
{
    comprconst.K2 = [anObject getdouble];
    return self;
}

- setcompressK3:anObject	// terminal input for compression const 3
{
    comprconst.K3 = [anObject getdouble];
    return self;
}



- setonflag:anObject
{
	if (!GRAPHICS) OnFlag = [anObject getint];
	else OnFlag = [gauss_on selectedRow];
	if (OnFlag==1 || OnFlag==3) {
		puts("Must use both tables:");
		loadiidtable();
		loadaztable();
	}
	return self;
}

- setOrder: anObject
{
    strb4_order = order = [anObject getint];
    return self;
}

- setazimuth:anObject
{
	az = [anObject getdouble];
	return self;
}

- (int)getazimuth:(double *)num
{
	if (GRAPHICS)
		az = [gauss_params doubleValueAt:2];
	*num = az;
	return OnFlag;
}

- getMean:(double *)num
{
	if (GRAPHICS)
		mean = [gauss_params doubleValueAt:0];
	*num = mean;
	return self;
}
    
- getVariance:(double *)num
{
	if (GRAPHICS)
        	deviation = [gauss_params doubleValueAt:1];
	*num = deviation;
	return self;
}

/*	To Lateralize or Calc CCF, all Stimulus panels call this routine for
	intensity and/or straightness weighting
*/

- dointensity:sender
{
    char temp[MAXPATHLEN-32];

	strcpy(temp, "/NextLibrary/Sounds/Funk.snd");

	if (GRAPHICS) {
		strb4_flag = StrFlag = [Str_on selectedRow];
		strb4_order = order = [Str_order intValueAt: 0];
		strb4_fstep = beforefstep = [Strbefore_fstep doubleValueAt:0];
		
		additive_on = [additiveOn state];
		additive_slope = [additiveSlope doubleValueAt:0];
		
		OnFlag = [gauss_on selectedRow];
		if (additive_on)
			OnFlag = 0;		// Treat add-IID as no intensity wghting
		mean = [gauss_params doubleValueAt:0];
		deviation = [gauss_params doubleValueAt:1];
		az = [gauss_params doubleValueAt:2];
		
		peakpick_thresh = [peakPickThresh doubleValueAt:0];
		peakpick_on = [peakPickOn selectedRow];
		if ((scale = [Scale doubleValueAt:0]) == 0)
			scale = 1;
			
		compress_on = [compressOn state];
		comprconst.K1 = [compressK doubleValueAt:0];
		comprconst.K2 = [compressK doubleValueAt:1];
		comprconst.K3 = [compressK doubleValueAt:2];
		
		raatgever_on = [raatgeverOn state];
	}
	
	if (sender == (ccf *)0)
		return self;
	
/***************************************************************************
	The appropriate stimulus CCF routine should have already calculated the CCF
	for the doubly-active case only.  We call the straightness routine now,
	and that routine will take care of the different fractions of active
	fiber pairs.
 ***************************************************************************/		
 	switch(OnFlag) {
		case 0:    /* no intensity function */
			// Lm = map(freq_sal_map, Lm);
			if (StrFlag == 1)
				Lm = old_ccf_str(Lm, order);
			else 
				Lm = ccf_str(Lm, order);
				
			if (Lm == (ccf *)0)		// Return and quit for bad CCF
				return self;
				
			break;
			
		case 1:	/* use azimuth table to determine m, v */
			azimuth = az;
			if (az > 180)
				printf("azimuth too high\n");
			azindex = az * AZCONST;
			f_old = 0;
			if (StrFlag == 1)
				Lm = old_ccf_str(Lm, order);
			else 
				Lm = ccf_str(Lm, order);
				
			if (Lm == (ccf *)0)		// Return and quit for bad CCF
				return self;

			Lm = map(gaussmap, Lm);

			break;
		       
		case 2:	/* use constant mean and standard deviation */
			if (GRAPHICS) {
				mean = [gauss_params doubleValueAt:0];
				deviation = [gauss_params doubleValueAt:1];
			} 
			f_old = 0;
			// Lm = map(freq_sal_map, Lm);
			if (StrFlag == 1)
				Lm = old_ccf_str(Lm, order);
			else 
				Lm = ccf_str(Lm, order);
				
			if (Lm == (ccf *)0)		// Return and quit for bad CCF
				return self;

			/*	frequency weighting before str. and inten. before??? */
			Lm = map(testmv, Lm);

			break;
			
		case 3:	/* Use IID table only */
			/*	Lm = map(freq_sal_map, Lm);	 */ 
			f_old = 0;
			if (StrFlag == 1)
				Lm = old_ccf_str(Lm, order);
			else 
				Lm = ccf_str(Lm, order);
				
			if (Lm == (ccf *)0)		// Return and quit for bad CCF
				return self;
				
			Lm = map(iidmap, Lm);

			break;
			
		default:
			printf("\n Select Error \n");
			break;
	 }
	 
	puts("freeing activeTable...");
	free(activeTable);		// clear active fraction table
				
	return self;
}

@end
