/* XXU - made to interpolate 2d arrays. */

#import <appkit/Form.h>
#import <appkit/Text.h>
#import <objc/Object.h>
#import "interp.h"

extern void exit(int);

#define FINISH      "finished !"
#define ISFILE    "file exists, overwrite"
#define MNOFILE    "cannot find the file"
#define IIDCONST  5     /* 5 pt per dB */
#define FCONST   10     /* 10 Hz per pt */
#define AZCONST  1
/* Path to look for tables in after checking ../tables path; also defined
   in Gauss.m */
#define PVMODEL_IIDTABLE "PVMODEL_IIDTABLE"
#define PVMODEL_AZTABLE "PVMODEL_AZTABLE"

@implementation interp
+ new
{
	self = [super new];
	return self;
}

- setArrayview:anObject
{
	arrayview = anObject;
	return self;
}

- setFilename:anObject
{
	filename = anObject;
	return self;
}

- setOut_filename:anObject
{
	out_filename = anObject;
	return self;
}

- setMessage:anObject;
{
	message=anObject;
	return self;
}

- setNumber:anObject
{
	number = anObject;
	return self;
}

- setInterpolation:anObject
{
	interpolation = anObject;
	return self;
}

- setHl_iview:anObject
{
	hl_iview = anObject;
	return self;
}

- setHh_iview:anObject
{
	hh_iview = anObject;
	return self;
}

- setVl_iview:anObject
{
	vl_iview = anObject;
	return self;
}

- setVh_iview:anObject
{
	vh_iview = anObject;
	return self;
}
- setXtitle:anObject
{
	xtitle=anObject;
	return self;
}

- setYtitle:anObject
{
	ytitle = anObject;
	return self;
}

- setTableType:anObject
{
   tableType = anObject;
   return self;
}

- setType:anObject
{
   type = anObject;
   return self;
}

- setRow:anObject
{
	row = anObject;
	return self;
}

- setColumn:anObject
{
	column = anObject;
	return self;
}

- setJumptitle:anObject
{
	jumptitle = anObject;
	return self;
}


- initArray:sender
{
	V_max = V_MAX;
	H_max = H_MAX;
	H_index = V_index = 0;
	[self displayArray];
	return self;
}

- updateArray:sender
{
	[self readback];
	printf("middle of updating array\n");
	[self displayArray];
	return self;
}
	
- displayArray
{
	id txt,xyvalue;
	int i,j,ind1,ind2;
	char str[20];
	float txt_gray,f;
	float num1,num2;
	
	//[NXWait set];  NXPing();
	
	for (i = V_index;i < V_index+10; i++) {
		for(j=H_index;j<H_index+10;j++) {
			ind1=(j-H_index)*2;
			txt = [arrayview cellAt:i-V_index:ind1];
			if ((i >= V_MAX)||(j >= H_MAX)) num1 = num2 = 0.0;
			else {
				num1 = Array[i][j].v1;
				num2 = Array[i][j].v2;
			}
			
			[txt setFloatValue:num1];
			if(Array[i][j].tag1==1) {
				txt_gray=1;
				[txt setTextGray:txt_gray];
			} else [txt setTextGray:0.0];
			
			ind2=ind1+1;
			txt =[arrayview cellAt:i-V_index:ind2];
			if(Array[i][j].tag2==1) {
				txt_gray=0.5;
				[txt setTextGray:txt_gray];
			} else [txt setTextGray:0.0];
			[txt setFloatValue:num2];
		/*	printf("\n %f,%f,%d,%d,%d,%d",num1,num2,ind1,ind2,i,j);*/
		}
	}
	
	tab_type = [tableType intValueAt:0];
	if (tab_type == 1) {
		[ytitle setStringValue:"Az\n(deg)"];
		[jumptitle setStringValue:"Go to Az:"];
		txt=[interpolation findCellWithTag:2];
		[txt setStringValue:"Az (deg)"];
		
		txt = [type findCellWithTag:1];
		[txt setStringValue:"IID:1"];
		txt = [type findCellWithTag:2];
		[txt setStringValue:"(dB)"];
		
		txt = [type findCellWithTag:3];
		[txt setStringValue:"ITD:2"];
		txt = [type findCellWithTag:4];
		[txt setStringValue:"(ms)"];
	} else {
		[ytitle setStringValue:"IID\n(dB)"];
		[jumptitle setStringValue:"Go to IID:"];
		txt = [interpolation findCellWithTag: 2];
		[txt setStringValue:"IID (dB)"];
		txt = [type findCellWithTag:1];
		[txt setStringValue:"mean:1"];
		txt = [type findCellWithTag:2];
		[txt setStringValue:"(ms)"];
		txt = [type findCellWithTag:3];
		[txt setStringValue:"var:2"];
		txt = [type findCellWithTag:4];
		[txt setStringValue:"(ms)"];
	}

	for(j=H_index;j<H_index+10;j++) {
		f=j*FCONST;
		xyvalue=[hl_iview findCellWithTag:j-H_index];
		[xyvalue setFloatValue:f];
	}

	for(j=V_index;j<V_index+10;j++) {	 
		num1=j;
		if(tab_type == 1)
		f=num1/AZCONST;
		else {
		/* printf("**** %f\n", num1/IIDCONST - (int) num1/IIDCONST);*/
f=(num1/IIDCONST - (int) num1/IIDCONST < .001) ? (num1/IIDCONST):((num1/IIDCONST)*100+1)/100;                             }
				/* printf("\n %d %f %f", j, num1, f); */
		xyvalue=[vl_iview findCellWithTag:j-V_index];
		[xyvalue setFloatValue:f];
	}
	return self;
}

- tag1:sender
  {
  id txt;
  int count;
  float txt_gray;
    txt=[arrayview selectedCell];
    txt_gray=[txt textGray];
    if(txt_gray==0.0)
    {
    txt_gray=1.0;
    [txt setTextGray:txt_gray];
    } else {
    txt_gray=0.0;
    [txt setTextGray:txt_gray];
    }
 return self;
 }
  
- tag2:sender
  {
  id txt;
  int count;
  float txt_gray;
    txt=[arrayview selectedCell];
    txt_gray=[txt textGray];
    if(txt_gray==0.0)
    {
    txt_gray=0.5;
    [txt setTextGray:txt_gray];
    } else {
    txt_gray=0.0;
    [txt setTextGray:txt_gray];
    }
 return self;
 }
   

- readback
{
	int i,j,ind1,ind2;
	id txt;
	float txt_gray;
	double tmp1,tmp2;
	
	for(i=V_index;i<V_index+10;i++)
		{
		for(j=H_index;j<H_index+10;j++)
			{
			ind1=(j-H_index)*2;
		        txt = [arrayview cellAt:i-V_index:ind1];
		        tmp1=[txt doubleValue];
			txt_gray=[txt textGray];
			if(txt_gray!=0.0)
			   Array[i][j].tag1=1;
			   else Array[i][j].tag1=0;
		        ind2=ind1+1;
		        txt =[arrayview cellAt:i-V_index:ind2];
		        tmp2=[txt doubleValue];
			txt_gray=[txt textGray];
			 if(txt_gray!=0.0)
			    Array[i][j].tag2=1;
			    else Array[i][j].tag2=0;
		         Array[i][j].v1=tmp1;
			 Array[i][j].v2=tmp2;
		        }
                   }
}

- jump:sender
{
  int newh,newv;
  double newhf,newvf;
  
  [self readback];
  [arrayview display];
  newhf = [column doubleValueAt:0];
  newvf = [row doubleValueAt:0];
  newh = newhf/FCONST;
  
  if(tab_type == 1)
    newv = newvf * AZCONST;
   else 
    newv = newvf * IIDCONST;
 /*   printf("newhf = %f, newvf = %f\n", newhf, newvf);
    printf("newh = %d, newv = %d\n", newh, newv);*/
    
  if (newh < H_MAX-10) H_index = newh;
  	else H_index = H_MAX - 10;
  if (newv < V_MAX-10) V_index = newv;
  	else V_index = V_MAX - 10;
  [self displayArray];
  return self;
}


- scrollup:sender
{
 [self readback];
  if (V_index > 0) V_index -= 1;
  [self displayArray];
  return self;
}

- scrolldown:sender
{
  [self readback];
  if (V_index < (V_MAX - 10)) V_index += 1;
  [self displayArray];
  return self;
}

- scrollleft:sender
{
  [self readback];
  if (H_index > 0) H_index -= 1;
  [self displayArray];
  return self;
}

- scrollright:sender
{
  [self readback];
  if (H_index < (H_MAX - 10)) H_index += 1;
  [self displayArray];
  return self;
}

- loadFile:sender
{
	double tmp1,tmp2;
	int a,f;
	FILE *fp;
	char str[20]="working ...";
	
	//[NXWait set];  NXPing();
	[message setStringValue:str at:0];
	if ((fp = fopen([filename stringValueAt:0], "r")) == NULL) {
		printf("can't find %s in ../tables or $PVMODEL_xxxTABLE variable\n", filename);
		[message setStringValue:MNOFILE at:0];
		exit(1);
	}
	printf("loading %s...%s\n", filename);
	
	fscanf(fp,"%d:%d",&V_max,&H_max);
	for(a=0;a<V_max;a++)
		{
		for(f=0;f<H_max;f++)
			{
			fscanf(fp,"%lf,%lf",&tmp1,&tmp2);
			Array[a][f].v1 = tmp1;
			Array[a][f].v2 = tmp2;
			}
		}
	//[NXArrow set];  NXPing();
	printf("finished loading table\n");
	[message setStringValue:FINISH at:0];
	fclose(fp);
	H_index = V_index = 0;
	[self displayArray];
    return self;
}
- saveFile:sender
{
	double tmp1,tmp2;
	int a,f;
	FILE *fp;
	
  	//[NXWait set];  NXPing();
	if ((fp = fopen([out_filename stringValueAt:0],"w")) == NULL)
		{
		printf("can't find %s; appending\n",filename);
		fp=fopen([out_filename stringValueAt:0],"a");
		}else {
	/*[self readback];*/
	[message setStringValue:"overwrite" at:0];
	printf("file exist, overwrite \n");
	}
	if (V_max < (V_index +10)) V_max = V_index + 10;
	if (H_max < (H_index +10)) H_max = H_index + 10;
	fprintf(fp,"%d:%d\n",V_max,H_max);
	for(a=0;a<V_max;a++)
		{
		for(f=0;f<H_max;f++)
			{
			tmp1 = Array[a][f].v1;
			tmp2 = Array[a][f].v2;
			fprintf(fp,"%lf,%lf\n",tmp1,tmp2);
			}
		}
		//[NXArrow set];  NXPing();
	        printf("finished saving table\n");
		fclose(fp);
		[message setStringValue:FINISH at:0];
  	return self;
}
  



- (int)getCLint
{
  id txt;
  int num;
  float numf;
	
  txt = [interpolation findCellWithTag:4];
  numf= [txt floatValue];
  num=numf/FCONST;
  return num;
}

- (int)getCHint
{
  id txt;
  int num;
  float numf;

  txt = [interpolation findCellWithTag:7];
  numf = [txt floatValue];
  num = numf/FCONST;
  return num;
}

- (int)getRLint
{
  id txt;
  int num;
  float numf;
	
  txt = [interpolation findCellWithTag:5];
  numf = [txt floatValue];
  if (tab_type == 1 )
  num = numf*AZCONST;
  else num = numf*IIDCONST;
  return num;
}

- (int)getRHint
{
  id txt;
  int num;
  float numf;
	
  txt = [interpolation findCellWithTag:8];
  numf = [txt floatValue];
  if(tab_type == 1)
  num = numf*AZCONST;
  else num = numf*IIDCONST;
  return num;
}

- interpolate:sender
{
	int rl, rh, cl, ch, i, j, which, con_h, con_v, k, m;
	double y2;
	int x[500];

	[self readback];
	rl = [self getRLint];
	rh = [self getRHint];
	cl = [self getCLint];
	ch = [self getCHint];
	printf("\n rl = %d, rh = %d, cl = %d, ch = %d",rl,rh,cl,ch);
	which = [number intValueAt:0];
	ch++;
	rh++;
	switch((int) which) {
		/***************************************************************/
		case 1: 
		for (j=cl; j<ch; j++) {
			con_v=0;
			for(i=rl;i<rh;i++) {
				if(Array[i][j].tag1!=0) {
					x[con_v]=i;
					con_v++;
				}
			}
		/* interpolating between known points */
			if(con_v>1) {
				for(k=1;k<con_v;k++) {
					y2=(Array[x[k]][j].v1-Array[x[k-1]][j].v1)/(x[k]-x[k-1]);
					for(m=x[k-1]+1;m<x[k];m++) {
						Array[m][j].v1=y2*(m-x[k-1])+Array[x[k-1]][j].v1;
						Array[m][j].tag1=2;
					}
				}
				/* exterpolating both ends */
				if (x[0]!=rl) {
					y2=(Array[x[1]][j].v1-Array[x[0]][j].v1)/(x[1]-x[0]);
					for(m=rl;m<x[0];m++) {
						Array[m][j].v1=Array[x[0]][j].v1-y2*(x[0]-m);
						Array[m][j].tag1=2;
					}
				}
				if(x[con_v-1]!=rh) {
					y2 = (Array[x[con_v-1]][j].v1-Array[x[con_v-2]][j].v1)
					   / (x[con_v-1]-x[con_v-2]);
					for(m=x[con_v-1]+1;m<rh;m++) {
						Array[m][j].v1 = y2*(m - x[con_v-1])
									   + Array[x[con_v-1]][j].v1;
						Array[m][j].tag1=2;
					}
				}
			} /* end of if */
		}   /* end of for */
	
		/* interpolation along rows */
		for(i=rl;i<rh;i++) {
			con_h=0;
			for(j=cl;j<ch;j++) {
				if(Array[i][j].tag1!=0) {
					x[con_h]=j;
					con_h++;
				}
			}
			if(con_h>1) {
			/* interpolating between known points */
				for(k=1;k<con_h;k++) {
					y2=(Array[i][x[k]].v1-Array[i][x[k-1]].v1)/(x[k]-x[k-1]);
					for(m=x[k-1]+1;m<x[k];m++)
					Array[i][m].v1=y2*(m-x[k-1])+Array[i][x[k-1]].v1;
				}  
			/* exterpolating both ends */
				if (x[0]!=cl) {
					y2=(Array[i][x[1]].v1-Array[i][x[0]].v1)/(x[1]-x[0]);
					for(m=cl;m<x[0];m++)
						Array[i][m].v1=Array[i][x[0]].v1-y2*(x[0]-m);
				}
				if(x[con_h-1]!=ch) {
					y2 = (Array[i][x[con_h-1]].v1-Array[i][x[con_h-2]].v1)
					   / (x[con_h-1]-x[con_h-2]);
					for(m=x[con_h-1]+1;m<ch;m++)
						Array[i][m].v1 = y2*(m-x[con_h-1])
									   + Array[i][x[con_h-1]].v1;
				}
			}      /* end of if */
		}
		break; 

		/***************************************************************/
		case 2:	
		for(j=cl;j<ch;j++) {
			con_v=0;
			for(i=rl;i<rh;i++) {
				if(Array[i][j].tag2!=0) {
					x[con_v]=i;
					con_v++;
				}
			}
			if(con_v>1) {
			/* interpolating between known points */
				for(k=1;k<con_v;k++) {
					y2=(Array[x[k]][j].v2-Array[x[k-1]][j].v2)/(x[k]-x[k-1]);
					for(m=x[k-1]+1;m<x[k];m++) {
						Array[m][j].v2=y2*(m-x[k-1])+Array[x[k-1]][j].v2;
						Array[m][j].tag2=2;
					}
				}
				/* exterpolating both ends */
				if (x[0]!=rl) {
					y2=(Array[x[1]][j].v2-Array[x[0]][j].v2)/(x[1]-x[0]);
					for(m=rl;m<x[0];m++) {
						Array[m][j].v2=Array[x[0]][j].v2-y2*(x[0]-m);
						Array[m][j].tag2=2;
					}
				}
				if (x[con_v-1]!=rh) {
					y2 = (Array[x[con_v-1]][j].v2-Array[x[con_v-2]][j].v2)
					   / (x[con_v-1]-x[con_v-2]);
					for(m=x[con_v-1]+1;m<rh;m++) {
						Array[m][j].v2 = y2*(m-x[con_v-1])
									   + Array[x[con_v-1]][j].v2;
						Array[m][j].tag2=2;
					}
				}
			}      // end of if */
		}	// end of outermost for
	
		/* interpolation along rows */

		for(i=rl; i<rh; i++) {
			con_h=0;
			for(j=cl;j<ch;j++) {
				if(Array[i][j].tag2!=0) {
					x[con_h]=j;
					con_h++;
				}
			}
			if(con_h>1) {
				/* interpolating between known points */
				for(k=1;k<con_h;k++) {
					y2=(Array[i][x[k]].v2-Array[i][x[k-1]].v2)/(x[k]-x[k-1]);
					for(m=x[k-1]+1;m<x[k];m++)
					Array[i][m].v2=y2*(m-x[k-1])+Array[i][x[k-1]].v2;
				}
			
				/* exterpolating both ends */
				if (x[0]!=cl) {
					y2=(Array[i][x[1]].v2-Array[i][x[0]].v2)/(x[1]-x[0]);
					for(m=cl;m<x[0];m++)
						Array[i][m].v2=Array[i][x[0]].v2-y2*(x[0]-m);
				}
				if(x[con_h-1]!=ch) {
					y2 = (Array[i][x[con_h-1]].v2-Array[i][x[con_h-2]].v2)
						/ (x[con_h-1]-x[con_h-2]);
					for(m=x[con_h-1]+1; m<ch; m++)
						Array[i][m].v2 = y2*(m-x[con_h-1])
									   + Array[i][x[con_h-1]].v2;
				}
			}  /* end of if */
		}
		break;
		
		/***************************************************************/
		default:
		printf("Wrong number: choose 1 or 2");
	}
	[self displayArray];
	return self;
}
  
@end
