/*
*	Kaiser.c -- Kaiser().  Kaiser-Bessel window function.
*
* HISTORY
*	Ver. 1.0  (7-15-86)
*	(5-25-89)	TOR - adapted for NeXT.
*/

#import <math.h>
#import "Nerve.h"

extern double I0(double x);

static double old_a = 0.0 , denom = 1.0;

double Kaiser(n, halfN, a)
	int	n, halfN;	/* time index, half window size */
				/*    0 <=  |n|  <= halfN    */
	double	a;		/* Window parameter (good choice: a = 3) */
{
	double f = ((double)n) / halfN;

	if (old_a != a)  {
		old_a = a;
		denom = I0(PI *a);
	}

	return I0(PI *a *sqrt(1.0 - f *f)) / denom;
}


