
/* Generated by Interface Builder */
/* XXU 2-14-1990 added optional modes for position calculation */

#import <appkit/Form.h>
#import "lateralizer.h"
#import "generalobj.h"
#import "ccf.h"
#import "BiDis.h"

#define ERROR "NO CCF Available.\n"

extern ccf *Lm;
extern id mytext;
extern int GRAPHICS;
extern double lateralize(ccf *lm);
extern double lateralize_a(ccf *lm);
extern double lateralize_b(ccf *lm), lateralize_c(ccf *lm);
extern addtext(id obj, char *str);
extern int OnFlag, order2;
extern double iid2, mean, deviation;
id lateral;
extern double scale;
extern int additive_on, compress_on;
extern double compress(double);

@implementation lateralizer

+ new
{
  self = [super new];
  lateral = self;
  return self;
}

- setLat_mess:anObject
{
    lat_mess = anObject;
    return self;
}

- setLat_type:anObject
{
    lat_type = anObject;
    return self;
}
  
- setStr_order: anObject
{
   str_order = anObject;
   return self;
}

- setStrafter_fstep: anObject
{
	Strafter_fstep= anObject;
	return self;
} 

- setstrafter_fstep: anObject
{
	afterfstep  = [anObject getdouble];
	return self;
} 
  

- setPtau_type: anObject
{
    ptau_type = anObject;
    return self;
}

- setpvflag:anObject
{
    if(!GRAPHICS)
		PvFlag=[anObject  getint];
    else 
		PvFlag = [lat_type selectedRow];

     return self;
}
 
- setPtFlag:anObject
{
	if(!GRAPHICS)
		PtauFlag=[anObject  getint];
	else 
		PtauFlag = [ptau_type selectedRow];

	return self;
}

 - setOrder: anObject
{
    order2 = [anObject getint];
    return self;
}

/* This method is used for the "Find Position" button in the Lateralize panel */  
- later:sender
{
    double position;
    char str[25];
    
	if (GRAPHICS)
		[lat_mess setStringValue:ERROR at:0];
	return self;

/*	To Find Position, you must do a Calc CCF or Lateralize (in Noise panel)
	to set up Lm structure.  Note:  if you Lateralize, it will free the CCF,
	so you must Calc CCF again.
*/
    if (Lm->storage != NULL) {
		if(PvFlag == 1) {
			if(GRAPHICS) {
				order2 = [str_order intValueAt: 0];
				afterfstep = [Strafter_fstep doubleValueAt:0];
			}
			  Lm = ccf_str(Lm, order2);

		}
			       
		if(PtauFlag==0)
			position = lateralize(Lm);
		else
			position = lateralize_c(Lm);
		printf("\nposition = %f\n", position);
		/* freeccf(Lm); */
		if (GRAPHICS)
			[lat_mess setDoubleValue:position at:0];
		sprintf(str,"%.8f\n",position);
		addtext(mytext,str);
	} else {
		if (GRAPHICS)
			[lat_mess setStringValue:ERROR at:0];
		addtext(mytext,ERROR);
	}
    return self;
}

/* This method is used to lateralize positions */
/* It is essentially the same as the previous method called later:self */
/* The Lateralize button in each Stimulus panel calls this method! */

- (double)findPosition: sender
{
    double position;
    char str[100];

     if (Lm->storage != NULL) {
	/* Use straightness after LI?  If so, redo Lm differently */
	if(PvFlag == 1) {
		if (GRAPHICS) {
			order2 = [str_order intValueAt: 0];
			afterfstep = [Strafter_fstep doubleValueAt:0];
		}
		printf("\n order = %d",order2);
		Lm = ccf_str(Lm,order2);
	}
			
	/* Use experimental Ptau? */	  
	if (PtauFlag == 0)
		position = lateralize(Lm);
	else
		position = lateralize_c(Lm);

	printf("\n position = %f ",position);
	if (GRAPHICS)
		[lat_mess setDoubleValue:position at:0];
		
     } else {
		if (GRAPHICS)
			[lat_mess setStringValue:ERROR at:0];
		addtext(mytext, ERROR);
	}
	if (scale != 1.0) {
		sprintf(str, ";P/=%f; mI=%.3f, wI=%.3f\n", scale, mean, deviation);
		addtext(mytext, str);
		position /= scale;
	}
	
	if (!additive_on && compress_on)
		return compress(position);
	return position;

}

@end
