/*	Nerve.h		*/
#import <math.h>

#define PI	3.14159265358979323846264338327950

#define NERVE_ACTIVE_RATE	200
#define NERVE_SPONT_RATE	50

// The following definitions are products of the above rates.
// They are pre-multiplied out to save computational time.
#define DOUBLY_ACTIVE_PROD	40000
#define SINGLY_ACTIVE_PROD 10000
#define SPONT_ACTIVE_PROD  2500

#define NERVE_NOISE_SLOPE(v)	(NERVE_ACTIVE_RATE*sqrt(2.*PI/(v)))
#define NERVE_TONE_SLOPE(v)	(NERVE_ACTIVE_RATE*PI/sqrt(2.*(v)))
#define NERVE_NOISE_VAR		(NERVE_ACTIVE_RATE*NERVE_ACTIVE_RATE*2.*PI)
#define NERVE_TONE_VAR		(NERVE_ACTIVE_RATE*NERVE_ACTIVE_RATE*PI*PI/2.)
