/*
*	newlpf.c -- New G(f) from D.Johnson synchronization data
*		assuming half-wave linear rectifier.
* HISTORY
*	???		GDS - Created.
*	5-31-87		GDS - Added G_HasChanged() routine for call
*			by lowpassinit().
*	6-30-88		TOR - fixed G_HasChanged() so that it works.
*	(5-24-89)	TOR - adapted for NeXT.
*/

#import "ccf.h"
#define K	(1. - fc/fs)

double fc = 1200.0;
double fs = 3200.0;


double GSqd(double f)	/* Hz */
{
/*         printf("\n fc = %f, fs = %f \n",fc, fs); */
	if (f <= fc)
		return 1.0;
	if (f < fs)
		return (1. - f/fs)*(1. - f/fs) / (K * K);
	return 0.0;
}

double G(double f)		/* Hz */
{
	if (f <= fc)
		return 1.0;
	if (f < fs)
		return (1. - f/fs) / K;
	return 0.0;
}

static double Old_fc = -1.0, Old_fs = -1.0;

/* 6-30-88 TOR - fixed fs mistake. */
int G_HasChanged(void)
{
	if (fc == Old_fc && fs == Old_fs)
		return 0;
	Old_fc = fc;
	Old_fs = fs;
	return 1;
}

