/*
*	
*			
*  HISTORY
*   XXU  3-26-90:  Created for the new ptau*Li function.
*/
#include <stdio.h>
#include <math.h>
#include "ccf.h"
#include "BiDis.h"
#import "Nerve.h"
#import "Gaussfunc.h"

#define ROOT2PI	2.506628275
#define FCONST 10	/* 10 Hz / pt */
#define IIDCONST 5	/* 5 pts / dB */

extern double sinc(double x);

   double	lF = 0.1,
	lP = -1.1, 
	hF = 3000., 
	hP = 0.0, 
	MuF = 0.2e-3, 
	MuP = 0.0,
	Fthresh = 1200.,
	m = 0.0,
	v = 1.778;
	
static double K = -1.0, L = -1., H = -1., mn = 0.0, l = -1., h = -1.;

double newptau(t,m,v)
	double t;	/* msec */
	double m,v;
{
	double tmp;
	t /= 1000.;
	tmp=v*v;
	printf("\n m = %f, v = %f ",m,v);

	if (fabs(t) <= mn) t = mn;
	if ((fabs(t)) <= 1.e-23) t = 2.*PI*K*(h-l)*exp((m*m-2*m*t)/2*tmp);
	else 
	{
	if (t <0)
	t = -K*(exp((2.*PI*l+m/tmp)*t) - exp((2.*PI*h+m/tmp)*t))/t;
	else
	t = K*(exp((-2.*PI*l+m/tmp)*t) - exp((-2.*PI*h+m/tmp)*t))/t;
	}
	errno = 0;
	return t;
}


nptauinit(f)
	double f;	/* freq. in Hz */
{
	double area = 0.0, tau;
	errno = 0;

	if (f > Fthresh) f = Fthresh;

	mn = MuF/pow(f, MuP);
	l = lF/pow(f, lP);
	h = hF/pow(f, hP);

	K = .5/Log(h/l);
	L = l*l;
	H = h*h;
	if (fabs(mn) > 0.0) {
		for (tau = 0.0; tau < DISP_TUP*DISP_TSTEP; tau += DISP_TSTEP)
			area += ptau(tau);
		area *= 2.*DISP_TSTEP/1000.;
		K /= area;
	}

	return 1;
}

static double prevf= -1.0;

double nptaumap(x, f, t)
	double x, f /* Hz */, t /* msec */;
{
	if (f != prevf) {
		nptauinit(f);
		prevf = f;
	}
	return x *ptau(t);
}

ccf *makeptau(L)
	ccf *L;
{
	ccf *P;

	P = newccf(L->f_low,L->f_up,L->fstep,L->t_low,L->t_up,L->tstep);
	beg_freq_loop(P)
	ptauinit(freq);
	beg_time_loop(P)
		P->R[f][t] = ptau(time);
	end_time_loop
	end_freq_loop
	return P;
}

