/* Generated by Interface Builder */
#import <objc/Object.h>
#import <appkit/Form.h>
#import <sound/sound.h>
#import "noiseCCF.h"
#import "generalobj.h"
#import "Gaussfunc.h"
#import "lateralizer.h"
#import "ccf.h"

#define DONE1 		"done with CCF func"
#define DONE2		"done with lateralization"
#define EMPTY 		"                  "
#define THINKING 	"Working..."
#define BADPARAM	"Bad choice of noise parameters"

extern int strb4_flag, strb4_order;
extern double strb4_fstep;
extern double scale;
extern ccf *Lm;
extern int GRAPHICS;
extern id mytext, lateral;
extern double iid2, mean, deviation;
extern int order2;
extern double additive_slope;
extern int additive_on, compress_on;

extern ccf *noise(double SPL, double IID, double fc, double ts, double ps, double bw);
extern double lateralize(ccf *Lm);
extern addtext(id obj,char *str);
extern char *strcpy(char *, char *);
extern double compress(double);

@implementation noiseCCF

- setMessageForm:anObject
{
    messageForm = anObject;
    return self;
}

- setBandwidth:anObject
{
    bandwidth = anObject;
    return self;
}

- setbw:anObject
{
	bw = [anObject getdouble];
	return self;
}

- setTime_shift:anObject
{
    time_shift = anObject;
    return self;
}

- setts:anObject
{
	ts = [anObject getdouble];
	return self;
}

- setFreq_center:anObject
{
    freq_center = anObject;
    return self;
}

- setfc:anObject
{
    fc = [anObject getdouble];
    return self;
}

- setFreq_inc:anObject
{
    freq_inc = anObject;
    return self;
}

- setincfc:anObject
{
    fcinc = [anObject getdouble];
    return self;
}

- setTime_inc:anObject
{
    time_inc = anObject;
    return self;
}

- setincts:anObject
{
    tsinc = [anObject getdouble];
    return self;
}

- setSpl_power:anObject
{
    spl_power = anObject;
    return self;
}

- setspl:anObject
{
    SPL = [anObject getdouble];
    return self;
}

- setPhase_shift:anObject
{
    phase_shift = anObject;
    return self;
}

- setps:anObject
{
    ps = [anObject getdouble];
    return self;
}

- setIterations:anObject
{
    iterations = anObject;
    return self;
}

- setiterate:anObject
{
    numiterate = [anObject getint];
    return self;
}

- setiid: anObject
{
   iid2 = [anObject getdouble];
   return self;
}

- setiid_inc: anObject
{
     iidinc= [anObject getdouble];
     return self;
}
 
- setIntensity: anObject
{
    intensity = anObject;
    return self;
}
 
 - setInten_inc: anObject
{
     inten_inc = anObject;
     return self;
}

- setBand_inc:anObject
{
    band_inc = anObject;
    return self;
}

- setincbw:anObject
{
    bwinc = [anObject getdouble];
    return self;
}

- setPhase_inc:anObject
{
    phase_inc = anObject;
    return self;
}

- setincps:anObject
{
    psinc = [anObject getdouble];
    return self;
}

- (char *)dumpParams
{
	char str[200];
	sprintf(str,"\nNOISE\nfc=%f\nbw=%f\nts=%f\nps=%f\nSPL=%f\n\0",
		fc, bw, ts, ps, SPL);
	return str;
}

- later_noise:sender
{
	int i;
	double position;
	char str[256], temp[MAXPATHLEN-32];

	strcpy(temp, "/NextLibrary/Sounds/Funk.snd");

	if (GRAPHICS) {
		[messageForm setStringValue:THINKING at:0];
		numiterate = [iterations intValueAt:0];
		ts = [time_shift doubleValueAt:0];
		SPL = [spl_power doubleValueAt:0];
		fc = [freq_center doubleValueAt:0];
		ps = [phase_shift doubleValueAt:0];
		bw = [bandwidth doubleValueAt:0];
		iid2 = [intensity doubleValueAt: 0];
		tsinc = [time_inc doubleValueAt:0];
		fcinc = [freq_inc doubleValueAt:0];
		psinc = [phase_inc doubleValueAt:0];
		bwinc = [band_inc doubleValueAt:0];
		iidinc = [inten_inc doubleValueAt: 0];
		/* Read in straightness fstep, order, flag */
		[gaussfunction dointensity:nil];
	}  

	sprintf(str,";ts=%.2f ps=%.1f fc=%.1f bw=%.1f iid=%.1f SPL=%.1f\n", ts, ps, fc, bw, iid2, SPL);
	addtext(mytext,str);
	if (strb4_flag) {
	    sprintf(str, ";order=%d str_fstep=%.4f\n", strb4_order, strb4_fstep);
	    addtext(mytext,str);
	}
	/* if (scale!=1.0) {
	    sprintf(str, ";position is divided by %f\n", scale);
	    addtext(mytext, str);
	} */
	if (tsinc!=0) {
	       x = ts;
	       xinc=tsinc;
	       sprintf(str,"; x = ts\n");
	       addtext(mytext,str);
	}  else if (fcinc!=0) {
	       x = fc;
	       xinc = fcinc;
	       sprintf(str,"; x = fc\n");
	       addtext(mytext,str);
	} else if (psinc != 0) {
	        x = ps;
	        xinc = psinc;
	       sprintf(str,"; x = ps\n");
	       addtext(mytext,str);
	} else if (bwinc !=0) {
	        x = bw;
	        xinc = bwinc;
	       sprintf(str,"; x = bw\n");
	       addtext(mytext,str);
	} else if (iidinc != 0) {
	        x = iid2;
	        xinc = iidinc;
	       sprintf(str,"; x = iid\n");
	       addtext(mytext,str);
	} else {
		x = iid2;	// ass. if no inc., output IID as abcissa
		xinc = 0;
		sprintf(str,";x = iid\n");
		addtext(mytext,str);
	}

	for (i = 1; i <= numiterate; i++,
								 ts += tsinc,
								 fc += fcinc,
								 iid2 += iidinc,
								 bw += bwinc,
								 ps += psinc,
								 x += xinc) {
		if ((Lm = noise(SPL, iid2, fc, ts, ps, bw)) == (ccf *)0) {
			[messageForm setStringValue:BADPARAM at:0];
			sprintf(str, ";bad choice of noise parameters\n");
			addtext(mytext, str);
			return self;
		}	

		[gaussfunction dointensity:self]; 
		position = [lateral findPosition:self];
		freeccf(Lm);

		if (GRAPHICS)
			[messageForm setDoubleValue:position at:0];

		if (additive_on) {
			double mm;
			mm = additive_slope;
			/**** Calculate position for various IIDs ****/
			if (compress_on) {
				sprintf(str, "\t-25\t%f\n", compress(position + mm * -25));
				addtext(mytext,str);
				sprintf(str, "\t-15\t%f\n", compress(position + mm * -15));
				addtext(mytext,str);
				sprintf(str, "\t-9\t%f\n", compress(position + mm * -9));
				addtext(mytext,str);
				sprintf(str, "\t-6\t%f\n", compress(position + mm * -6));
				addtext(mytext,str);
				sprintf(str, "\t-3\t%f\n", compress(position + mm * -3));
				addtext(mytext,str);
				sprintf(str, "\t0\t%f\n", compress(position + mm * 0));
				addtext(mytext,str);
				sprintf(str, "\t3\t%f\n", compress(position + mm * 3));
				addtext(mytext,str);
				sprintf(str, "\t6\t%f\n", compress(position + mm * 6));
				addtext(mytext,str);
				sprintf(str, "\t9\t%f\n", compress(position + mm * 9));
				addtext(mytext,str);
				sprintf(str, "\t15\t%f\n", compress(position + mm * 15));
				addtext(mytext,str);
				sprintf(str, "\t25\t%f\n",	compress(position + mm * 25));
				addtext(mytext,str);
			} else {
				sprintf(str, "\t-25\t%f\n", (position + mm * -25));
				addtext(mytext,str);
				sprintf(str, "\t-15\t%f\n", (position + mm * -15));
				addtext(mytext,str);
				sprintf(str, "\t-9\t%f\n", (position + mm * -9));
				addtext(mytext,str);
				sprintf(str, "\t-6\t%f\n", (position + mm * -6));
				addtext(mytext,str);
				sprintf(str, "\t-3\t%f\n", (position + mm * -3));
				addtext(mytext,str);
				sprintf(str, "\t0\t%f\n", (position + mm * 0));
				addtext(mytext,str);
				sprintf(str, "\t3\t%f\n", (position + mm * 3));
				addtext(mytext,str);
				sprintf(str, "\t6\t%f\n", (position + mm * 6));
				addtext(mytext,str);
				sprintf(str, "\t9\t%f\n", (position + mm * 9));
				addtext(mytext,str);
				sprintf(str, "\t15\t%f\n", (position + mm * 15));
				addtext(mytext,str);
				sprintf(str, "\t25\t%f\n", (position + mm * 25));
				addtext(mytext,str);
			}
		} else {
			sprintf(str,"%10.3f %5.5f\n", x, position);
			addtext(mytext, str);
		}
	}
	
	
	if (GRAPHICS) {
		[time_shift setDoubleValue:ts at:0];
		[freq_center setDoubleValue:fc at:0];
		[phase_shift setDoubleValue:ps at:0];
		[bandwidth setDoubleValue:bw at:0];
		[intensity setDoubleValue:iid2 at:0];
		[messageForm setStringValue:DONE2 at:0];
	}
	
	// if (globpath(temp))
	SNDPlaySoundfile(temp, 1);
			
	return self;
}

- ccf_noise:sender
{
	char str[256], temp[MAXPATHLEN-32];
	
	strcpy(temp, "/NextLibrary/Sounds/Funk.snd");

	if (GRAPHICS) {
		[messageForm setStringValue:THINKING at:0];
		//[NXWait set]; NXPing();
		ts = [time_shift doubleValueAt:0];
		SPL = [spl_power doubleValueAt:0];
		fc = [freq_center doubleValueAt:0];
		ps = [phase_shift doubleValueAt:0];
		bw = [bandwidth doubleValueAt:0];
		iid2 = [intensity doubleValueAt:0];
		[gaussfunction dointensity:nil];
	}
    Lm = noise(SPL, iid2, fc, ts, ps, bw);
	if (Lm == (ccf *)0) {
		[messageForm setStringValue:BADPARAM at:0];
		sprintf(str, ";bad choice of noise parameters\n");
		addtext(mytext, str);
		return self;
	}	

    [gaussfunction dointensity:self];
    putinfoccf(Lm, [self dumpParams]);
    if (GRAPHICS) {
		[messageForm setStringValue:DONE1 at:0];
    }
	
	// if (globpath(temp))
	SNDPlaySoundfile(temp, 1);
			
    return self;
}


@end
