#import <appkit/Form.h>
#import <math.h>
#import "paramsCCF.h"
#import "generalobj.h"

extern double Flow, Fup;
extern int GRAPHICS;

double DISP_TSTEP;
double DISP_FSTEP;
double DISP_NFIBERS_STEP;
int DISP_NFIBERS_TOTAL;   /* number of fibers. */
int DISP_TUP, DISP_TLOW;

@implementation paramsCCF

+ initialize
{
	DISP_TSTEP = 0.025;
	DISP_FSTEP = 0.01;
	DISP_TUP = 200;
	DISP_TLOW = -200;
	DISP_NFIBERS_TOTAL = 30000;
	DISP_NFIBERS_STEP = DISP_NFIBERS_TOTAL * DISP_FSTEP / 3.;
}

- setTime_high:anObject
{
    time_high = anObject;
    return self;
}

- setFindex_low:anObject
{
    findex_low = anObject;
    return self;
}

- setFindex_high:anObject
{
    findex_high = anObject;
    return self;
}

- setTindex_high:anObject
{
    tindex_high = anObject;
    return self;
}

- setTime_low:anObject
{
    time_low = anObject;
    return self;
}

- setTime_step:anObject
{
    time_step = anObject;
    return self;
}

- setFreq_step:anObject
{
    freq_step = anObject;
    return self;
}

- setTindex_low:anObject
{
    tindex_low = anObject;
    return self;
}

- settstep:anObject
{
	DISP_TSTEP = [anObject getdouble];
	return self;
}

- setfstep:anObject
{
	DISP_FSTEP = [anObject getdouble];
	DISP_NFIBERS_STEP = DISP_NFIBERS_TOTAL * DISP_FSTEP / 3.;
	return self;
}

- settupper:anObject
{
	DISP_TUP = [anObject getdouble] / DISP_TSTEP;
	return self;
}

- settlower:anObject
{
	DISP_TLOW = [anObject getdouble] / DISP_TSTEP;
	return self;
}

- submit:sender
{
    int flow, fhigh;
    
	if (GRAPHICS) {
    	DISP_TSTEP = [time_step doubleValueAt:0];
    	DISP_TUP = [time_high doubleValueAt:0] / DISP_TSTEP;
    	DISP_TLOW = [time_low doubleValueAt:0] / DISP_TSTEP;
    	DISP_FSTEP = [freq_step doubleValueAt:0];
		DISP_NFIBERS_STEP = DISP_NFIBERS_TOTAL * DISP_FSTEP / 3.;
    	flow = log10(Flow)/DISP_FSTEP;
    	fhigh = log10(Fup)/DISP_FSTEP;
    	[tindex_low setIntValue:DISP_TLOW at:0];
    	[tindex_high setIntValue:DISP_TUP at:0];
    	[findex_low setIntValue:flow at:0];
    	[findex_high setIntValue:fhigh at:0];
	}
    return self;
}

@end
