
/* Generated by Interface Builder */

#import <appkit/Form.h>
#import <sound/sound.h>
#import "raatCCF.h"
#import "generalobj.h"
#import "Gaussfunc.h"
#import "lateralizer.h"
#import "ccf.h"

#define DONE1 		"done with CCF func"
#define DONE2		"done with lateralization"
#define EMPTY 		"                  "
#define THINKING 	"Working..."
#define BADPARAM	"Bad choice of noise parameters"

extern id mytext,lateral;
extern int GRAPHICS;
extern int strb4_flag, strb4_order;
extern double strb4_fstep;
extern double scale;
extern ccf *Lm;
extern double additive_slope;
extern int additive_on, compress_on;

extern ccf *RaatNoise(double SPL, double iid2, double dlnw,
					  double nfl, double nfu,
					  double wfl, double wfu,
					  double nts, double wts);
extern double lateralize(ccf *lm);
extern addtext(id obj,char *str);
extern double iid2,mean,deviation;
extern addtext(id obj,char *str);
extern char *strcpy(char *, char *);
extern double compress(double);

@implementation raatCCF

/*********************** NeXTstep model parameters **********************/
- setInc_param:anObject
{
    inc_param = anObject;
    return self;
}

- setIterations:anObject
{
    iterations = anObject;
    return self;
}

- setMessageForm:anObject
{
    messageForm = anObject;
    return self;
}

- setRaat_param:anObject
{
    raat_param = anObject;
    return self;
}

/*********************** Console model parameters **********************/
- setwts:anObject
{
	wts = [anObject getdouble];
	return self;
}

- setnts:anObject
{
	nts = [anObject getdouble];
	return self;
}

- setwfu:anObject
{
	wfu = [anObject getdouble];
	return self;
}

- setwfl:anObject
{
	wfl = [anObject getdouble];
	return self;
}

- setnfu:anObject
{
	nfu = [anObject getdouble];
	return self;
}

- setnfl:anObject
{
	nfl = [anObject getdouble];
	return self;
}

- setdlnw:anObject
{
	dlnw = [anObject getdouble];
	return self;
}

- setspl:anObject
{
	SPL = [anObject getdouble];
	return self;
}

- setiterate:anObject
{
	numiterate = [anObject getint];
	return self;
}

- setincwts:anObject
{
	wtsinc = [anObject getdouble];
	return self;
}

- setincnts:anObject
{
	ntsinc = [anObject getdouble];
	return self;
}

- setincwfu:anObject
{
	wfuinc = [anObject getdouble];
	return self;
}

- setincwfl:anObject
{
	wflinc = [anObject getdouble];
	return self;
}

- setincnfu:anObject
{
	nfuinc = [anObject getdouble];
	return self;
}

- setincnfl:anObject
{
	nflinc = [anObject getdouble];
	return self;
}

- setincdlnw:anObject
{
	dlnwinc = [anObject getdouble];
	return self;
}

- setiid: anObject
{
   iid2 = [anObject getdouble];
   return self;
}

- setiid_inc: anObject
{
     iidinc= [anObject getdouble];
     return self;
 }
 
/* - setIntensity: anObject
{
    intensity = anObject;
    return self;
 }
 
 - setInten_inc: anObject
 {
     inten_inc = anObject;
     return self;
}*/

/************************* Executable methods **************************/
- (char *)dumpParams
{
	char str[200];
	sprintf(str, "RAATNOISE\nwts = %f wfu = %f wfl = %f\nnts = %f nfu = %f nfl = %f\ndlnw = %f\nSPL = %f\n", wts, wfu, wfl, nts, nfu, nfl, dlnw, SPL);
	return str;
}

- later_raat:sender
{
    int i;
    double position;
	char str[128], temp[MAXPATHLEN-32];
    
    if (GRAPHICS) {
		numiterate = [iterations intValueAt:0];
		wts = [raat_param doubleValueAt:0];
		nts = [raat_param doubleValueAt:1];
		wfu = [raat_param doubleValueAt:2];
		wfl = [raat_param doubleValueAt:3];
		nfu = [raat_param doubleValueAt:4];
		nfl = [raat_param doubleValueAt:5];
		iid2 = [raat_param doubleValueAt:6];
		dlnw = [raat_param doubleValueAt:7];
		SPL = [raat_param doubleValueAt:8];
		
		wtsinc = [inc_param doubleValueAt:0];
		ntsinc = [inc_param doubleValueAt:1];
		wfuinc = [inc_param doubleValueAt:2];
		wflinc = [inc_param doubleValueAt:3];
		nfuinc = [inc_param doubleValueAt:4];
		nflinc = [inc_param doubleValueAt:5];
		iidinc = [inc_param doubleValueAt:6];
		dlnwinc = [inc_param doubleValueAt:7];
		
		[gaussfunction dointensity:nil];
	}
	sprintf(str, "
;wts=%.2f nts=%.2f
;wfu=%.1f wfl=%.1f
;nfu = %.1f nfl=%.1f
;dlnw=%.2f iid=%.1f SPL=%.1f\n",
		wts, nts, wfu, wfl, nfu, nfl, dlnw, iid2,  SPL);
	addtext(mytext, str);
	if (strb4_flag) {
	    sprintf(str, ";order=%d str_fstep=%.4f\n", strb4_order, strb4_fstep);
	    addtext(mytext,str);
	}
	if(wtsinc!= 0) {
		x = wts;
		xinc=wtsinc;
		sprintf(str,"\n; x = wts\n");
		addtext(mytext,str);
	}  else if(ntsinc != 0) {
		x = nts;
		xinc = ntsinc;
		sprintf(str,"\n; x = nts\n");
		addtext(mytext,str);
	}  else if(wfuinc != 0) {
		x = wfu;
		xinc = wfuinc;
		sprintf(str,"\n; x = wfu\n");
		addtext(mytext,str);
	}  else if(wflinc !=  0) {
		x = wfl;
		xinc = wflinc;
		sprintf(str,"\n; x = wfl\n");
		addtext(mytext,str);
	} else if(nfuinc != 0) {
		x = nfu;
		xinc = nfuinc;
		sprintf(str,"\n; x = nfu\n");
		addtext(mytext,str);
	} else if(nflinc != 0) {
		x = nfl;
		xinc = nflinc;
		sprintf(str,"\n; x = nfl\n");
		addtext(mytext,str);
	} else if (dlnwinc != 0) {
		x = dlnw;
		xinc = dlnwinc;
		sprintf(str,"\n; x = nfl\n");
		addtext(mytext,str);
	} else if(iidinc != 0) {
		x = iid2;
		xinc = iidinc;
		sprintf(str,"\n; x = ts\n");
		addtext(mytext,str);
	} else {
		x = iid2;	// ass. if no inc., output IID as abcissa
		xinc = 0;
		sprintf(str,";x = iid\n");
		addtext(mytext,str);
	}

    for(i = 1; i <= numiterate; i++,
								wts += wtsinc, nts += ntsinc,
								wfu += wfuinc, wfl += wflinc,
								nfu += nfuinc, nfl += nflinc,
								dlnw += dlnwinc,
								iid2 += iidinc, x += xinc) {
		if ((Lm = RaatNoise(SPL, iid2, dlnw, nfl, nfu, wfl, wfu, nts, wts))
				== (ccf *)0) {
			[messageForm setStringValue:BADPARAM at:0];
			sprintf(str, ";bad choice of noise parameters\n");
			addtext(mytext, str);
			return self;
		}	

		[gaussfunction dointensity:self];
		position = [lateral findPosition:self];
		freeccf(Lm);
	
		if (GRAPHICS)
			[messageForm setDoubleValue:position at:0];

		if (additive_on) {
			double mm;
			mm = additive_slope;
			/**** Calculate position for various IIDs ****/
			if (compress_on) {
				sprintf(str, "\t-25\t%f\n", compress(position + mm * -25));
				addtext(mytext,str);
				sprintf(str, "\t-15\t%f\n", compress(position + mm * -15));
				addtext(mytext,str);
				sprintf(str, "\t-9\t%f\n", compress(position + mm * -9));
				addtext(mytext,str);
				sprintf(str, "\t-6\t%f\n", compress(position + mm * -6));
				addtext(mytext,str);
				sprintf(str, "\t-3\t%f\n", compress(position + mm * -3));
				addtext(mytext,str);
				sprintf(str, "\t0\t%f\n", compress(position + mm * 0));
				addtext(mytext,str);
				sprintf(str, "\t3\t%f\n", compress(position + mm * 3));
				addtext(mytext,str);
				sprintf(str, "\t6\t%f\n", compress(position + mm * 6));
				addtext(mytext,str);
				sprintf(str, "\t9\t%f\n", compress(position + mm * 9));
				addtext(mytext,str);
				sprintf(str, "\t15\t%f\n", compress(position + mm * 15));
				addtext(mytext,str);
				sprintf(str, "\t25\t%f\n",	compress(position + mm * 25));
				addtext(mytext,str);
			} else {
				sprintf(str, "\t-25\t%f\n", (position + mm * -25));
				addtext(mytext,str);
				sprintf(str, "\t-15\t%f\n", (position + mm * -15));
				addtext(mytext,str);
				sprintf(str, "\t-9\t%f\n", (position + mm * -9));
				addtext(mytext,str);
				sprintf(str, "\t-6\t%f\n", (position + mm * -6));
				addtext(mytext,str);
				sprintf(str, "\t-3\t%f\n", (position + mm * -3));
				addtext(mytext,str);
				sprintf(str, "\t0\t%f\n", (position + mm * 0));
				addtext(mytext,str);
				sprintf(str, "\t3\t%f\n", (position + mm * 3));
				addtext(mytext,str);
				sprintf(str, "\t6\t%f\n", (position + mm * 6));
				addtext(mytext,str);
				sprintf(str, "\t9\t%f\n", (position + mm * 9));
				addtext(mytext,str);
				sprintf(str, "\t15\t%f\n", (position + mm * 15));
				addtext(mytext,str);
				sprintf(str, "\t25\t%f\n", (position + mm * 25));
				addtext(mytext,str);
			}
		} else {
			sprintf(str,"%10.3f %5.5f\n", x, position);
			addtext(mytext, str);
		}	
	}
	
	if (GRAPHICS) {
		[raat_param setDoubleValue:wts at:0];
		[raat_param setDoubleValue:nts at:1];
		[raat_param setDoubleValue:wfu at:2];
		[raat_param setDoubleValue:wfl at:3];
		[raat_param setDoubleValue:nfu at:4];
		[raat_param setDoubleValue:nfl at:5];
		[raat_param setDoubleValue:iid2 at:6];
		[raat_param setDoubleValue:dlnw at:7];
		[raat_param setDoubleValue:SPL at:8];

		[messageForm setStringValue:DONE2 at:0];
	}
	
	SNDPlaySoundfile(temp, 1);
    return self;
}

- ccf_raat:sender
{
	char str[64], temp[MAXPATHLEN-32];
	
	strcpy(temp, "/NextLibrary/Sounds/Funk.snd");
	
	if (GRAPHICS) {
    	[messageForm setStringValue:THINKING at:0];
    	wts = [raat_param doubleValueAt:0];
    	nts = [raat_param doubleValueAt:1];
    	wfu = [raat_param doubleValueAt:2];
    	wfl = [raat_param doubleValueAt:3];
    	nfu = [raat_param doubleValueAt:4];
    	nfl = [raat_param doubleValueAt:5];
    	dlnw = [raat_param doubleValueAt:6];
    	SPL = [raat_param doubleValueAt:7];
		[gaussfunction dointensity:nil];
	}
    Lm = RaatNoise(SPL, iid2, dlnw,  nfl, nfu, wfl, wfu, nts, wts);
	if (Lm == (ccf *)0) {
		[messageForm setStringValue:BADPARAM at:0];
		sprintf(str, ";bad choice of noise parameters\n");
		addtext(mytext, str);
		return self;
	}	

    [gaussfunction dointensity:self];
    putinfoccf(Lm,[self dumpParams]);
    if (GRAPHICS)
		[messageForm setStringValue:DONE1 at:0];
	
	SNDPlaySoundfile(temp, 1);
	
    return self;
}


@end
