/*
*	threshold.c -- Piecewise linear approximation to threshold of hearing
*			ANSI 1964 Audiometer.  (As determined by Rich Stern
*			9/1/76)
*	(5-24-89)	TOR - adapted for NeXT.
*	(7-24-89)	TOR - had #define ConstThresh 10 but removed later
*/

#import <math.h>

double threshold(double f)
{
	if (f <  500.)
		return (11.+44.846*log10(500./f)-6.5);
	if (f < 1000.)
		return (11.-14.9847*log10(f/500.)-6.5);
	if (f < 2500.)
		return (0.0);	/* 0.0=6.5-6.5 */
	return (6.5+28.7044*log10(f/2500.)-6.5);
}
