/* Generated by Interface Builder */

#import <appkit/Form.h>
#import <sound/sound.h>
#import "toneCCF.h"
#import "generalobj.h"
#import "Gaussfunc.h"
#import "lateralizer.h"
#import "ccf.h"
#import "text.h"

#define DONE1 		"Done with CCF calc"
#define DONE2		"Done with lateralization"
#define EMPTY 		"                             "
#define THINKING 	"Thinking..."
#define BADPARAM	"Bad choice of tone parameters"

extern int strb4_flag, strb4_order;
extern double strb4_fstep;
extern ccf *Lm;
extern id mytext, lateral;
extern int GRAPHICS;
extern double iid2, mean, deviation;
extern double additive_slope;
extern int additive_on, compress_on;
extern double scale;

extern ccf *tone(double spl, double iid2, double fc, double ts);
extern double lateralize(ccf *Lm);
extern addtext(id obj, char *str);
extern char *strcpy(char *, char *);
extern double compress(double);

@implementation toneCCF

- setSpl_power:anObject
{
    spl_power = anObject;
    return self;
}

- setspl:anObject
{
    SPL = [anObject getdouble];
    return self;
}

- setMessageForm:anObject
{
    messageForm = anObject;
    return self;
}

- setTime_inc:anObject
{
    time_inc = anObject;
    return self;
}

- setincts:anObject
{
    tsinc = [anObject getdouble];
    return self;
}

- setIterations:anObject
{
    iterations = anObject;
    return self;
}

- setiterate:anObject
{
    numiterate = [anObject getint];
    return self;
}

- setFreq_center:anObject
{
    freq_center = anObject;
    return self;
}

- setfc:anObject
{
    fc = [anObject getdouble];
    return self;
}

- setFreq_inc:anObject
{
    freq_inc = anObject;
    return self;
}

- setincfc:anObject
{
    freqinc = [anObject getdouble];
    return self;
}

- setTime_shift:anObject
{
    time_shift = anObject;
    return self;
}

- setts:anObject
{
    ts = [anObject getdouble];
    return self;
}

- setiid: anObject
{
	iid2 = [anObject getdouble];
	return self;
}

- setiid_inc: anObject
{
	iidinc= [anObject getdouble];
	return self;
}
 
- setIntensity: anObject
{
    intensity = anObject;
    return self;
}
 
- setInten_inc: anObject
{
    inten_inc = anObject;
    return self;
}



- (char *)dumpParams
{
    char str[100];
    sprintf(str,"TONES\nfc = %f\nts = %f\nSPL = %f\n",fc,ts,SPL);
    return str;
}

- later_tone:sender
{
    int i;
    double position;
    char str[256], temp[MAXPATHLEN-32];

	strcpy(temp, "/NextLibrary/Sounds/Funk.snd");

    if (GRAPHICS) {    
		[messageForm setStringValue:THINKING at:0];
		// NXPing();
		numiterate = [iterations intValueAt:0];
		ts = [time_shift doubleValueAt:0];
		SPL = [spl_power doubleValueAt:0];
		fc = [freq_center doubleValueAt:0];
		tsinc = [time_inc doubleValueAt:0];
		freqinc = [freq_inc doubleValueAt:0];
		iid2 = [intensity doubleValueAt: 0];
		iidinc = [inten_inc doubleValueAt: 0];
		[gaussfunction dointensity:nil];
    }
    sprintf(str, ";ts=%.2f fc=%.1f iid=%.1f SPL=%.1f\n", ts, fc, iid2, SPL);
    addtext(mytext, str);
    if (strb4_flag) {
		sprintf(str, ";order=%d str_fstep=%.4f\n", strb4_order, strb4_fstep);
		addtext(mytext,str);
    }
    /* if (scale!=1.0) {
		sprintf(str, ";position is divided by %f\n", scale);
		addtext(mytext, str);
    } */
    if(tsinc!= 0) {
		x = ts;
		xinc=tsinc;
		sprintf(str,"; x = ts\n");
		addtext(mytext, str);
    } else if(freqinc!=0) {
		x = fc;
		xinc = freqinc;
		sprintf(str,"; x = fc\n");
		addtext(mytext, str);
    } else if(iidinc != 0) {
		x = iid2;
		xinc = iidinc;
		sprintf(str,"; x = ts\n");
		addtext(mytext, str);
    } else {
		x = iid2;	// ass. if no inc., output IID as abcissa
		xinc = 0;
		sprintf(str,"; x = iid\n");
		addtext(mytext, str);
	}
	for(i=1; i<=numiterate; i++, ts+=tsinc,fc+=freqinc,iid2+=iidinc,x+=xinc) {
		/* Now tone has IID as argument */
		Lm = tone(SPL, iid2, fc, ts);
		if (Lm == (ccf *)0) {
			[messageForm setStringValue:BADPARAM at:0];
			sprintf(str, ";bad choice of tone parameters\n");
			addtext(mytext, str);
			return self;
		}
			
		[gaussfunction dointensity:self];
		if (Lm == (ccf *)0) {
			[messageForm setStringValue:BADPARAM at:0];
			sprintf(str, ";bad choice of tone parameters\n");
			addtext(mytext, str);
			return self;
		}	

		position = [lateral findPosition:self];
		freeccf(Lm);
		if (GRAPHICS)
			[messageForm setDoubleValue:position at:0];

		if (additive_on) {
			double mm;
			mm = additive_slope;
			/**** Calculate position for various IIDs ****/
			if (compress_on) {
				sprintf(str, "\t-25\t%f\n", compress(position + mm * -25));
				addtext(mytext,str);
				sprintf(str, "\t-15\t%f\n", compress(position + mm * -15));
				addtext(mytext,str);
				sprintf(str, "\t-9\t%f\n", compress(position + mm * -9));
				addtext(mytext,str);
				sprintf(str, "\t-6\t%f\n", compress(position + mm * -6));
				addtext(mytext,str);
				sprintf(str, "\t-3\t%f\n", compress(position + mm * -3));
				addtext(mytext,str);
				sprintf(str, "\t0\t%f\n", compress(position + mm * 0));
				addtext(mytext,str);
				sprintf(str, "\t3\t%f\n", compress(position + mm * 3));
				addtext(mytext,str);
				sprintf(str, "\t6\t%f\n", compress(position + mm * 6));
				addtext(mytext,str);
				sprintf(str, "\t9\t%f\n", compress(position + mm * 9));
				addtext(mytext,str);
				sprintf(str, "\t15\t%f\n", compress(position + mm * 15));
				addtext(mytext,str);
				sprintf(str, "\t25\t%f\n",	compress(position + mm * 25));
				addtext(mytext,str);
			} else {
				sprintf(str, "\t-25\t%f\n", (position + mm * -25));
				addtext(mytext,str);
				sprintf(str, "\t-15\t%f\n", (position + mm * -15));
				addtext(mytext,str);
				sprintf(str, "\t-9\t%f\n", (position + mm * -9));
				addtext(mytext,str);
				sprintf(str, "\t-6\t%f\n", (position + mm * -6));
				addtext(mytext,str);
				sprintf(str, "\t-3\t%f\n", (position + mm * -3));
				addtext(mytext,str);
				sprintf(str, "\t0\t%f\n", (position + mm * 0));
				addtext(mytext,str);
				sprintf(str, "\t3\t%f\n", (position + mm * 3));
				addtext(mytext,str);
				sprintf(str, "\t6\t%f\n", (position + mm * 6));
				addtext(mytext,str);
				sprintf(str, "\t9\t%f\n", (position + mm * 9));
				addtext(mytext,str);
				sprintf(str, "\t15\t%f\n", (position + mm * 15));
				addtext(mytext,str);
				sprintf(str, "\t25\t%f\n", (position + mm * 25));
				addtext(mytext,str);
			}
		} else {
			sprintf(str,"%10.3f %5.5f\n", x, position);
			addtext(mytext, str);
		}
	}
	
    if (GRAPHICS) {
		[time_shift setDoubleValue:ts at:0];
		[freq_center setDoubleValue:fc at:0];
		[intensity setDoubleValue:iid2 at:0];
		[messageForm setStringValue:DONE2 at:0];	
    }

	// if (globpath(temp))
	SNDPlaySoundfile(temp, 1);
			
    return self;
}

- ccf_tone:sender
{
    char str[64], temp[MAXPATHLEN-32];

	strcpy(temp, "/NextLibrary/Sounds/Funk.snd");

	if (GRAPHICS) {
		[messageForm setStringValue:THINKING at:0];
		NXPing();
		ts = [time_shift doubleValueAt:0];
		SPL = [spl_power doubleValueAt:0];
		fc = [freq_center doubleValueAt:0];
		iid2 = [intensity doubleValueAt: 0];
		[gaussfunction dointensity:nil];
	}
    
	Lm = tone(SPL, iid2, fc, ts);
	if (Lm == (ccf *)0) {
		[messageForm setStringValue:BADPARAM at:0];
		sprintf(str, ";bad choice of tone parameters\n");
		addtext(mytext, str);
		return self;
	}
    
    [gaussfunction dointensity:self];
	if (Lm == (ccf *)0) {
		[messageForm setStringValue:BADPARAM at:0];
		sprintf(str, ";bad choice of tone parameters\n");
		addtext(mytext, str);
		return self;
	}
    
    putinfoccf(Lm, [self dumpParams]);
    if (GRAPHICS)
		[messageForm setStringValue:DONE1 at:0];

	// if (globpath(temp))
	SNDPlaySoundfile(temp, 1);
			
    return self;
}


@end
